package com.zsc.edu.dify.exception;

import org.springframework.stereotype.Component;

import java.util.function.Supplier;

@Component
public class ExceptionUtil {

    public static <T> T difyException(Supplier<T> supplier) throws ApiException {
        try {
            return supplier.get();
        } catch (RuntimeException e) {
            System.err.println(e.getMessage());
            throw new ApiException("出现错误，请联系工作人员！报错信息："+e.getMessage());
        }
    }

}
