package com.zsc.edu.dify.modules.dify.service.Impl;

import com.alibaba.fastjson2.JSON;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.zsc.edu.dify.modules.dify.entity.WorkflowData;
import com.zsc.edu.dify.modules.dify.mapper.WorkflowMapper;
import com.zsc.edu.dify.modules.dify.repo.WorkflowRepository;
import com.zsc.edu.dify.modules.dify.service.AppEntityService;
import com.zsc.edu.dify.modules.dify.service.DifyWorkflowService;
import io.github.guoshiqiufeng.dify.workflow.DifyWorkflow;
import io.github.guoshiqiufeng.dify.workflow.dto.request.WorkflowRunRequest;
import io.github.guoshiqiufeng.dify.workflow.dto.response.WorkflowRunResponse;
import jakarta.annotation.Resource;
import lombok.AllArgsConstructor;
import org.springframework.stereotype.Service;

import java.nio.ByteBuffer;

@AllArgsConstructor
@Service
public class DifyWorkflowServiceImpl extends ServiceImpl<WorkflowRepository, WorkflowData> implements DifyWorkflowService {
    @Resource
    AppEntityService appEntityService;
    @Resource
    DifyWorkflow difyWorkflow;
    @Resource
    WorkflowMapper mapper;

    /**
     * 运行保存信息
     * @param request
     * @param appId
     * @return
     */
    @Override
    public WorkflowRunResponse run(WorkflowRunRequest request, String appId){
        String apiKey = appEntityService.getApikey(appId);
        request.setApiKey(apiKey);
        WorkflowRunResponse response = difyWorkflow.runWorkflow(request);
        WorkflowData workflowData =mapper.toEntity(response);
        workflowData.setAppId(appId);
        workflowData.setData(response.getData());
        baseMapper.insert(workflowData);
        return response;
    }

    @Override
    public WorkflowData detail(Long id) {
        WorkflowData workflowData = this.getById(id);
        if(workflowData == null){
            throw new RuntimeException("未找到数据");
        }
        WorkflowRunResponse.WorkflowRunData parsedData =
                JSON.parseObject(baseMapper.getData(id), WorkflowRunResponse.WorkflowRunData.class);
        workflowData.setData(parsedData);
        return workflowData;
    }

    @Override
    public Page<WorkflowData> query(Page<WorkflowData> page){
        return baseMapper.selectPage(page,new QueryWrapper<>());
    }

    @Override
    public boolean delete(Long id){
        return baseMapper.deleteById(id) > 0;
    }
}
